-- Script SQL Oracle de cration de deux types avec relation 1-n bidirectionnelles
-- Suppression du schma
DROP TABLE Livre 
/
DROP TABLE Editeur 
/
DROP TYPE tableRefLivresType FORCE
/
DROP TYPE LivreRefType 
/
DROP TYPE LivreType 
/
DROP TYPE EditeurType
/
DROP TYPE TypeDonnesAnne
/
DROP TABLE Utilisateur
/
DROP TYPE UtilisateurType
/
DROP TYPE PersonneType
/

-- Cration du schma
CREATE OR REPLACE TYPE TypeDonnesAnne AS OBJECT
(valeurAnne	INTEGER)
/
CREATE OR REPLACE TYPE EditeurType
/
CREATE TYPE LivreType AS OBJECT
(ISBN				CHAR(13),
 titre			VARCHAR(50),
 anneParution		TypeDonnesAnne,
 diteur			REF EditeurType
)
/
CREATE OR REPLACE TYPE LivreRefType AS OBJECT
(livreRef	REF	LivreType)
/
CREATE TYPE tableRefLivresType AS
TABLE OF LivreRefType
/
CREATE OR REPLACE TYPE EditeurType AS OBJECT
(nomEditeur 		VARCHAR(20),
 ville 			VARCHAR(20),
 lesLivres			tableRefLivresType
)
/
CREATE TABLE Editeur OF EditeurType
(PRIMARY KEY(nomEditeur))
NESTED TABLE lesLivres STORE AS tableLesLivres
/
CREATE TABLE Livre OF LivreType
(PRIMARY KEY(ISBN),
CONSTRAINT anneSup0 CHECK(anneParution.valeurAnne > 0),
CONSTRAINT referenceTableEditeur diteur SCOPE IS Editeur)
/
-- Insertion de deux diteurs 
INSERT INTO Editeur VALUES
 	('Loze-Dion', 'Longueuil',tableRefLivresType())
/
INSERT INTO Editeur VALUES
 	('Addison-Wesley', 'Reading, MA',tableRefLivresType())
/
-- Insertion de livres
INSERT INTO Livre
SELECT '0-201-12227-8', 'Automatic Text Processing',
 	TypeDonnesAnne(1989), REF(e)
	FROM Editeur e WHERE nomEditeur = 'Addison-Wesley'
/
INSERT INTO THE
 	(SELECT e.lesLivres FROM Editeur e 
 	 WHERE e.nomEditeur = 'Addison-Wesley')
	SELECT REF(l) FROM Livre l 
 	WHERE l.ISBN = '0-201-12227-8'
/
INSERT INTO Livre
SELECT '0-8053-1755-4', 'Fundamentals of Database Systems',
 	TypeDonnesAnne(2000), REF(e)
	FROM Editeur e WHERE nomEditeur = 'Addison-Wesley'
/
INSERT INTO THE
 	(SELECT e.lesLivres FROM Editeur e 
 	 WHERE e.nomEditeur = 'Addison-Wesley')
	SELECT REF(l) FROM Livre l 
 	WHERE l.ISBN = '0-8053-1755-4'
/
-- Exemples de requtes
SELECT l.diteur.nomEditeur, l.ISBN
FROM Livre l
WHERE l.diteur.ville = 'Reading, MA'
/
SELECT livres.livreRef.ISBN, livres.livreRef.titre
FROM THE 
(SELECT e.lesLivres FROM Editeur e WHERE nomEditeur = 'Addison-Wesley') livres
/
CREATE TYPE PersonneType AS OBJECT
(nom		VARCHAR(10),
 prnom 	VARCHAR(10)) NOT FINAL
/
CREATE TYPE UtilisateurType UNDER PersonneType
(idUtilisateur		VARCHAR(10),
 motPasse		VARCHAR(10),
 catgorieUtilisateur	VARCHAR(14))
/
CREATE TABLE Utilisateur OF UtilisateurType
/
INSERT INTO Utilisateur VALUES(1,'cocorico','Marshal', 'Amanda', 'membre')
/
INSERT INTO Utilisateur VALUES(2,'cocorico','Degas', 'Edgar', 'membre')
/
INSERT INTO Utilisateur VALUES(3,'cocorico','Lecommis', 'Coco', 'employ')
/
INSERT INTO Utilisateur VALUES(4,'cocorico','Lecommis', 'Toto', 'employ')
/